#library(urbanR)
#library(RNetCDF)
library(sp)
library(sf)
#library(mapview)
#library(ncdf4)
#library(rgeos) 
library(ggplot2)
library(plyr) #OJO! la llibreria plyr ha de ser cridada abans que dplyr 
library(dplyr) 
#library(broom)
#library(magrittr)
library(ggpubr)
library(raster)
#library(rgdal)
#library(tmap)
library(gstat)
library(sp)
library(abind)
library(openair)
library(tidyr)
#library(RColorBrewer)
#library(Metrics)
#library(gbm)
#library(lubridate)
#library(matrixStats)
library(leaflet)
library(viridis)
library(viridisLite)



shp_admin <- read_sf("/home/abarrant/esarchive/scratch/ccarnere/AQS_database/shp/divisions_admin/catalunya/divisions-administratives-v2r1-catalunya-5000-20230928.shp")


path_sp      <- "/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/stats_results/"

pixels_UK_gbm <- readRDS(paste0(path_sp, "annual_pixels_UK_gbm.rds"))
pixels_UK     <- readRDS(paste0(path_sp, "annual_pixels_UK.rds"))
pixels_count_gbm <- readRDS(paste0(path_sp, "annual_pixels_count_daylimit_UK_GBM.rds"))





ggplot() + 
  geom_tile(as.data.frame(pixels_UK), mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno", limits=c(5, 25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )

  
ggplot() + 
  geom_tile(as.data.frame(pixels_UK_gbm), mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno", limits=c(5, 25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )






df_delta <- as.data.frame(pixels_UK)
df_uk <- as.data.frame(pixels_UK)
df_uk_gbm <- as.data.frame(pixels_UK_gbm)

df_delta$var1.pred <- df_uk_gbm$var1.pred - df_uk$var1.pred


ggplot() + 
  geom_tile(df_delta, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_viridis_c(option="inferno") +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill =  expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )




ggplot() + 
  geom_tile(df_uk, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_stepsn(colors=c( "#7F3F80", "#CF5A8B", "#F4A54B", "yellow2"),breaks=c(5,10,15,20,25), limits=c(5,25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill = expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )

ggplot() + 
  geom_tile(df_uk_gbm, mapping=aes(x = coords.x1, y = coords.x2, fill = var1.pred)) +
  geom_sf(data=shp_admin, fill=NA, color="black") +
  scale_fill_stepsn(colors=c( "#7F3F80", "#CF5A8B", "#F4A54B", "yellow2"),breaks=c(5,10,15,20,25), limits=c(5,25)) +
  theme_minimal() +
  labs(x = "Longitude",
       y = "Latitude",
       fill = expression("PM2.5\n(\u03bcg/m³)")) +
  theme(
    legend.position = c(0.79, 0.075),  
    legend.justification = c(0.1, 0.0001),   
    legend.background = element_rect(fill = "white", color="white", linewidth = 6),
    legend.box.margin = margin(t = 5, r = 5, b = 5, l = 5)
  )











































#-------------------------------------------------------------------------------

pollutants       <- c("pm2p5")
years            <- c(2019) 


general_path <- "/esarchive/scratch/abarrant/results_regional_"
save_sp      <- "/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/stats_results/"


compute_in_UTM   <- "TRUE"
crs_latlon       <- "+proj=longlat +datum=WGS84 +ellps=WGS84 +towgs84=0,0,0"
crs_utm          <- "+proj=utm +zone=31 +ellps=intl +units=m +no_defs"


#my_box            <- rgeos::bbox2SP(43.02355,40.24870,3.497162,-0.001190186, proj4string = CRS(crs_latlon)) # lat màx, lat min, lon max, lon min
my_box            <- rgeos::bbox2SP(43.0,40.25,3.485,0.01, proj4string = CRS(crs_latlon)) # lat màx, lat min, lon max, lon min
if (compute_in_UTM) {
  my_box <- spTransform(my_box, sp::CRS(crs_utm))
}
# Generate an uniform mesh
receptor_grid                     <- sf::st_sf(geom=sf::st_make_grid(my_box, n=c(100,100), what = "centers"), crs=crs_latlon)
sp_receptor_grid                  <- sf::as_Spatial(receptor_grid)
sp::proj4string(sp_receptor_grid) <- crs_utm

#rang <- c(0,10,20,30,40,80,120,160,200,300,400)
rang <-seq(0, 50, 2)
rang_annual <- c(0, 5, 10, 20, 25, 300)
filesname <- "UK_gene_pm2p5"     #uk
#filesname <- "UK_gene_pm2p5_gbm" #uk gbm


p<- 1
pollutant     <- pollutants[p]
save_final_sp <- paste0(save_sp,pollutant,"_matrix")


y <- 1
year            <- years[y]

pollutant_path  <- paste0(general_path,year,"/results_gene_",pollutant, "/output")
path_model      <- paste0(pollutant_path,"/df_annual_uk.rds")            #ja estic agafant la mitjana
#path_model      <- paste0(pollutant_path,"/model_gene_",pollutant,".rds")  
path_coords     <- paste0(pollutant_path,"/coords_model_gene_",pollutant,".rds")

coords_model    <- readRDS(file = path_coords)

lon_model       <- coords_model[, "lon_model"]
lat_model       <- coords_model[, "lat_model"]
#model_corrected <- readRDS(file=path_model)
#df_annual_mean  <- readRDS(file=path_model)


file_list <- list.files(pollutant_path, pattern = paste0(filesname,"_\\d{8}\\.rds$"), full.names = TRUE)
file_list <- file_list[-6]


sum_matrix <- NULL                    #matriu on posarem la suma total
count_matrix <- numeric(82844)        #matriu de cada cop q se suma valor a la posicio (per dividir quan fem la mitjana)
count_daylimit <- numeric(82844)      #matriu de les vegades q se supera el limit diari


##FILTRAR ELS NUMEROS NEGATIUS!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

for (file in file_list) {
  #file <- file_list[2]
  current_matrix <- readRDS(file)[[1]]
  current_matrix <- ifelse(current_matrix < 0, 0, current_matrix)  #fer 0 totes les concentracions q donin negatives
  
  #iniciar quan es nul.la
  if (is.null(sum_matrix)) {
    sum_matrix     <- current_matrix
    
    for (i in 1:length(current_matrix)) {
      if (!is.na(current_matrix[i])) {  #mirar si el valor no es nan
        count_matrix[i] <- count_matrix[i] + 1
      }
    }
  } else{
    #sumar sempre q no sigui nan
    for (i in 1:length(current_matrix)) {
      if (!is.na(current_matrix[i])) { 
        sum_matrix[i] <- sum_matrix[i] + current_matrix[i]
        count_matrix[i] <- count_matrix[i] + 1
      }
    }
  }
  
  #comptador diari per veure si supera el limit diari de 15um/m3
  for (i in 1:length(current_matrix)) {
    if (!is.na(current_matrix[i])){
      if (current_matrix[i] > 15) {  
        count_daylimit[i] <- count_daylimit[i] + 1
      }
    }
  }
  
}

annual_mean <- sum_matrix/count_matrix   


#save the values from each file
#data_list <- lapply(file_list, function(file_path) {
#data <- readRDS(file_path)
#return(data[[1]]) 
#})

#data_matrix <- do.call(cbind, data_list)  #convert into a dataframe (rows are points, cols are days)


#Annual mean
#annual_mean                      <- rowMeans(data_matrix, na.rm = TRUE)
df_annual_mean                   <- data.frame(pollutant=annual_mean, lon=lon_model, lat=lat_model)
coordinates(df_annual_mean)      <- ~lon+lat
sp::proj4string(df_annual_mean)  <- crs_latlon

if (compute_in_UTM) {
  df_annual_mean <- spTransform(df_annual_mean, sp::CRS(crs_utm))
}

set.seed(1) #we are picking random points in the next line, set.seed permits us to have same points in each loop
df_annual_mean     <- na.omit(df_annual_mean)
pick_random_points <- sample(1:nrow(df_annual_mean),30000)
pollutant.fit_ok   <- automap::autofitVariogram(formula=pollutant~1, input_data=df_annual_mean[pick_random_points,],model="Ste")
#pollutant.fit_ok   <- automap::autofitVariogram(formula=pollutant~1, input_data=df_annual_mean,model="Ste")
ok_gstat           <- gstat(formula=pollutant~1, data = df_annual_mean, model = pollutant.fit_ok$var_model, nmax=25)
OK                 <- predict(object=ok_gstat, newdata=sp_receptor_grid)

#saveRDS(object=OK, file=paste0(general_path,"OK_UK_sp.rds"))

pixels      <- sp::SpatialPixelsDataFrame(OK, as.data.frame(OK[,"var1.pred"]))
#pixels      <- sp::SpatialPixelsDataFrame(OK,tolerance = 0.99, as.data.frame(OK@data$var1.pred))
mean_raster <- raster::raster(pixels[,'var1.pred'])





#plots-----------------------------------------------------------

save_sp      <- "/home/abarrant/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/stats_results/"
#pixels <- readRDS(paste0(save_sp,"annual_pixels_UK.rds"))
#mean_raster <- readRDS(paste0(save_sp,"annual_mean_raster_UK.rds"))

pixels <- readRDS(paste0(save_sp,"annual_pixels_UK_gbm.rds"))
mean_raster <- readRDS(paste0(save_sp,"annual_mean_raster_UK_gbm.rds"))

#pixels <- readRDS(paste0(save_sp,"annual_pixels_count_daylimit_UK_GBM.rds"))

#spain <- ne_states(country = "Spain", returnclass = "sf")
#cat <- spain[spain$name == "Catalonia", ]
#pixels_cat <- st_intersection(pixels, catalonia)

rang <-seq(0, 30, 2)
rang_annual <- c(0, 5, 10, 20, 25, 100)
rang_days<- c(0,2,4, 6, 8, 10, 15, 20, 25, 30, 365)
color_palette <- colorNumeric(palette = viridis(256), domain = pixels$var1.pred)


# mapview::mapview(OK$var1.pred, at=rang)
# mapview::mapview(datos_leidos, at=rang)
#mapview::mapview(mean_raster, at=rang)
mapview::mapview(pixels, zcol="var1.pred", at=rang_annual)
#mapview::mapview(pixels, zcol="var1.pred", at=rang)
#mapview::mapview(pixels, zcol="var1.pred", at=rang_days)
mapview::mapview(pixels, zcol="var1.pred", col.regions=viridis(256))
























# Mitjanes a cada punt ------------------------------------------------------------------

general_path <- "/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/output/"
save_sp      <- "/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/stats_results/"


#undia <- readRDS(paste0(general_path,"UK_gene_pm2p5_20190101.rds"))

#funcio per juntar tots els df, fem la mitjana de cada pixel a tot lany
annual_result <- function(filesname) {
  #list of all file names (format caracteristic)
  file_list <- list.files(general_path, pattern = paste0(filesname,"_\\d{8}\\.rds$"), full.names = TRUE)
  
  #save the values from each file
  data_list <- lapply(file_list, function(file_path) {
    data <- readRDS(file_path)
    return(data[[1]]) 
  })
  
  #convert into a dataframe (rows are points, cols are days)
  data_matrix <- do.call(cbind, data_list)
  
  #mean of each point, row mean over all days
  mean_vector <- rowMeans(data_matrix, na.rm = TRUE)
  
  #guardem les dades amb la mateixa estructura q els rds dentrada
  result_mean_df <- data_list[[1]]  #estructura
  result_mean_df <- mean_vector
  return(result_mean_df)
}

df_annual_uk     <- annual_result("UK_gene_pm2p5")
df_annual_uk_gbm <- annual_result("UK_gene_pm2p5_gbm")


saveRDS(object=df_annual_uk, file=paste0(general_path,"df_annual_uk.rds"))
saveRDS(object=df_annual_uk_gbm, file=paste0(general_path, "df_annual_uk_gbm.rds"))





